/*	$Id: dllist.h,v 1.4 2005/08/22 21:48:34 phil Exp $ */

/* BLURB gpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2005 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

*/


#ifndef _DLIST_H
#define _DLIST_H


struct dllist_head {	
	struct dllist_head *next;
	struct dllist_head *prev;
};


#define dllist_chain dllist_head

#define list_entry(ptr, type, member) \
	((type *)((char *)(ptr)-(unsigned long)(&((type *)0)->member)))

#endif

#define LIST_HEAD(name) \
	struct dllist_head name = { &name, &name }


void list_add(struct dllist_head *entry, struct dllist_head *head);
void list_del(struct dllist_head *entry);
int list_empty(struct dllist_head *entry);
void list_init(struct dllist_head *lh);


